/*
 * GccApplication1.c
 *
 * Created: 5/19/2018 9:37:12 PM
 * Author : XPS 9360
 */ 

#include <avr/io.h>
#include <util/delay.h>
#include "lcd.h"

void task1_lcd()
{
	// configurare porturi folosite
	DDRB &= ~(1 << PB2);
	DDRD &= ~(1 << PD6);
	PORTB |= (1 << PB2);
	PORTD |= (1 << PD6);

	// initializari
	char str[] = "Hello World";
	LCD_print(str);

	// main loop
	int8_t pos = 0;
	uint8_t PINB_old = 0xff;
	uint8_t PIND_old = 0xff;
	for(;;)
	{
		uint8_t PINB_crt = PINB;
		uint8_t PIND_crt = PIND;

		if((PINB_old & (1 << PB2)) && !(PINB_crt & (1 << PB2)))
		{
			pos += 1;
			if(pos + (sizeof(str) - 1) > 16)
			pos = 16 - (sizeof(str) - 1);

			LCD_writeInstr(LCD_INSTR_clearDisplay);
			LCD_printAt(pos, str);
		}

		if((PIND_old & (1 << PD6)) && !(PIND_crt & (1 << PD6)))
		{
			pos -= 1;
			if(pos < 0)
			pos = 0;

			LCD_writeInstr(LCD_INSTR_clearDisplay);
			LCD_printAt(pos, str);
		}

		PINB_old = PINB_crt;
		PIND_old = PIND_crt;

		_delay_ms(5);
	}
}


int main(void)
{
		//setare pini pt semafoare ca output
		DDRB |= (1 << PB0);
		PORTB &= ~(1 << PB0);
		DDRB |= (1 << PB1);
		PORTB &= ~(1 << PB1);
		DDRB |= (1 << PB2);
		PORTB &= ~(1 << PB2);
		DDRB |= (1 << PB3);
		PORTB &= ~(1 << PB3);
		DDRB |= (1 << PB4);
		PORTB &= ~(1 << PB4);
		DDRB |= (1 << PB5);
		PORTB &= ~(1 << PB5);
		DDRB |= (1 << PB6);
		PORTB &= ~(1 << PB6);
		DDRB |= (1 << PB7);
		PORTB &= ~(1 << PB7);

	while(1) {
		
		int i=0;
			
			//rosu la semafor1 pt masini 
			for(i=0; i<700;i++){
							
				PORTB |= (1 << PB0);
				PORTB &= ~(1 << PB1);
				PORTB &= ~(1 << PB2);
				PORTB &= ~(1 << PB3);
				PORTB &= ~(1 << PB4);
				PORTB |= (1 << PB5);
				PORTB |= (1 << PB6);
				PORTB |= (1 << PB7);
		
				_delay_ms(70);
	
				PORTB |= (1 << PB0);
				PORTB &= ~(1 << PB1);
				PORTB &= ~(1 << PB2);
				PORTB &= ~(1 << PB3);
				PORTB |= (1 << PB4);
				PORTB |= (1 << PB5);
				PORTB &= ~(1 << PB6);
				PORTB |= (1 << PB7);	
				
				_delay_ms(70);	
			
				PORTB &= ~(1 << PB0);
				PORTB |= (1 << PB1);
				PORTB &= ~(1 << PB2);
				PORTB &= ~(1 << PB3);
				PORTB |= (1 << PB4);
				PORTB &= ~(1 << PB5);
				PORTB |= (1 << PB6);
				PORTB |= (1 << PB7);
			
				_delay_ms(70);	
			
				PORTB &= ~(1 << PB0);
				PORTB |= (1 << PB1);
				PORTB &= ~(1 << PB2);
				PORTB &= ~(1 << PB3);
				PORTB |= (1 << PB4);
				PORTB |= (1 << PB5);
				PORTB |= (1 << PB6);
				PORTB &= ~(1 << PB7);
		
				_delay_ms(70);	
			
				
				PORTB &= ~(1 << PB0);
				PORTB &= ~(1 << PB1);
				PORTB |= (1 << PB2);
				PORTB &= ~(1 << PB3);
				PORTB |= (1 << PB4);
				PORTB |= (1 << PB5);
				PORTB &= ~(1 << PB6);
				PORTB |= (1 << PB7);
				
				_delay_ms(70);	

				PORTB &= ~(1 << PB0);
				PORTB &= ~(1 << PB1);
				PORTB |= (1 << PB2);
				PORTB &= ~(1 << PB3);
				PORTB |= (1 << PB4);
				PORTB |= (1 << PB5);
				PORTB |= (1 << PB6);
				PORTB &= ~(1 << PB7);
				
				_delay_ms(70);	
		}	
		
		
		
		
		
			//galben la semafor1 pt masini
				for(i=0; i<300;i++){
					
				PORTB |= (1 << PB0);
				PORTB &= ~(1 << PB1);
				PORTB &= ~(1 << PB2);
				PORTB &= ~(1 << PB3);
				PORTB &= ~(1 << PB4);
				PORTB |= (1 << PB5);
				PORTB |= (1 << PB6);
				PORTB |= (1 << PB7);
						
				_delay_ms(70);
						
				PORTB |= (1 << PB0);
				PORTB &= ~(1 << PB1);
				PORTB &= ~(1 << PB2);
				PORTB &= ~(1 << PB3);
				PORTB |= (1 << PB4);
				PORTB |= (1 << PB5);
				PORTB &= ~(1 << PB6);
				PORTB |= (1 << PB7);
						
				_delay_ms(70);
						
				PORTB |= (1 << PB0);
				PORTB &= ~(1 << PB1);
				PORTB &= ~(1 << PB2);
				PORTB &= ~(1 << PB3);
				PORTB |= (1 << PB4);
				PORTB &= ~(1 << PB5);
				PORTB |= (1 << PB6);
				PORTB |= (1 << PB7);
			
				_delay_ms(70);
						
				PORTB |= (1 << PB0);
				PORTB &= ~(1 << PB1);
				PORTB &= ~(1 << PB2);
				PORTB &= ~(1 << PB3);
				PORTB |= (1 << PB4);
				PORTB |= (1 << PB5);
				PORTB |= (1 << PB6);
				PORTB &= ~(1 << PB7);
						
				_delay_ms(70);	

				PORTB &= ~(1 << PB0);
				PORTB &= ~(1 << PB1);
				PORTB &= ~(1 << PB2);
				PORTB |= (1 << PB3);
				PORTB &= ~(1 << PB4);
				PORTB |= (1 << PB5);
				PORTB |= (1 << PB6);
				PORTB |= (1 << PB7);
						
				_delay_ms(70);

				PORTB &= ~(1 << PB0);
				PORTB &= ~(1 << PB1);
				PORTB &= ~(1 << PB2);
				PORTB |= (1 << PB3);
				PORTB |= (1 << PB4);
				PORTB |= (1 << PB5);
				PORTB |= (1 << PB6);
				PORTB &= ~(1 << PB7);
					
					_delay_ms(70);
				}
	
				  
			//verde la semfor1 pt masini
			for(i=0; i<700;i++){
				
				PORTB |= (1 << PB0);	
				PORTB &= ~(1 << PB1);
				PORTB &=~(1 << PB2);
				PORTB &= ~(1 << PB3);
				PORTB |= (1 << PB4);
				PORTB &= ~(1 << PB5);
				PORTB |= (1 << PB6);
				PORTB |= (1 << PB7);
			
				_delay_ms(70);
			
				PORTB |= (1 << PB0);
				PORTB &= ~(1 << PB1);
				PORTB &= ~(1 << PB2);
				PORTB &= ~(1 << PB3);
				PORTB |= (1 << PB4);
				PORTB |= (1 << PB5);
				PORTB |= (1 << PB6);
				PORTB &= ~(1 << PB7);
			
				_delay_ms(70);

				PORTB &= ~(1 << PB0);
				PORTB |= (1 << PB1);
				PORTB &= ~(1 << PB2);
				PORTB &= ~(1 << PB3);
				PORTB &= ~(1 << PB4);
				PORTB |= (1 << PB5);
				PORTB |= (1 << PB6);
				PORTB |= (1 << PB7);
			
				_delay_ms(70);
			
				PORTB &= ~(1 << PB0);
				PORTB |= (1 << PB1);
				PORTB &= ~(1 << PB2);
				PORTB &= ~(1 << PB3);
				PORTB |= (1 << PB4);
				PORTB |= (1 << PB5);
				PORTB &= ~(1 << PB6);
				PORTB |= (1 << PB7);
			
				_delay_ms(70);
			
				PORTB &= ~(1 << PB0);
				PORTB &= ~(1 << PB1);
				PORTB |= (1 << PB2);
				PORTB &=~(1 << PB3);
				PORTB &= ~(1 << PB4);
				PORTB |= (1 << PB5);
				PORTB |= (1 << PB6);
				PORTB |= (1 << PB7);
		
				_delay_ms(70);

				PORTB &= ~(1 << PB0);
				PORTB &= ~(1 << PB1);
				PORTB |= (1 << PB2);
				PORTB &= ~(1 << PB3);
				PORTB |= (1 << PB4);
				PORTB &= ~(1 << PB5);
				PORTB |= (1 << PB6);
				PORTB |= (1 << PB7);
			
				_delay_ms(70);
				}
	
	}
}

